﻿-- recup main addon object
if not BLTNorushen then return end
local BLTNorushen = BLTNorushen

local AceDB = LibStub("AceDB-3.0")

local count=0
local debug=false
local bossfight=false
local Lwasteoftime = "Very well, I will create a field to keep your corruption quarantined."
local currentdps=1

local prepulltime=25
local rotationtime=15
local beforetime=5

function BLTNorushen:print_r ( t )
    local print_r_cache={}
    local function sub_print_r(t,indent)
        if (print_r_cache[tostring(t)]) then
            print(indent.."*"..tostring(t))
        else
            print_r_cache[tostring(t)]=true
            if (type(t)=="table") then
                for pos,val in pairs(t) do
                    if (type(val)=="table") then
                        print(indent.."["..pos.."] => "..tostring(t).." {")
                        sub_print_r(val,indent..string.rep(" ",string.len(pos)+8))
                        print(indent..string.rep(" ",string.len(pos)+6).."}")
                    else
                        if type(pos) == "table" then
							print(indent.."[-table-] => "..tostring(val))
						else
							print(indent.."["..pos.."] => "..tostring(val))
						end
                    end
                end
            else
                print(indent..tostring(t))
            end
        end
    end
    sub_print_r(t," ")
end

local function startDebug()
	if debug then
		print("Simulating CHAT_MSG_MONSTER_YELL >> "..Lwasteoftime)
	end
	BLTNorushen:CHAT_MSG_MONSTER_YELL("event", Lwasteoftime)
end

function BLTNorushen:SlashProcessor_BLTNorushen(input)
	local v1, v2 = input:match("^(%S*)%s*(.-)$")
	v1 = v1:lower()

	if v1 == "" then
		print("|cffc41f3bBloodlust Norushen|r: /BLTNorushen config - Open configuration panel")
		print("|cffc41f3bBloodlust Norushen|r: /BLTNorushen debug - Toggle debug")
		print("|cffc41f3bBloodlust Norushen|r: /BLTNorushen start - Manual start")
		print("|cffc41f3bBloodlust Norushen|r: /BLTNorushen stop - Manual stop")
	elseif v1 == "config" then
		BLTNorushen.InitOptions()
	elseif v1 == "start" then
		print("BLTNorushen manual start")
		startDebug()
	elseif v1 == "stop" then
		print("BLTNorushen manual stop")
		bossfight = false
  elseif v1 == "time" then
    rotationtime = tonumber(v2)
    print("|cffc41f3bBloodlust Norushen|r Rotation time set to "..tostring(rotationtime).."sec")
	elseif v1 == "debug" then
		if debug then
			print("BLTNorushen DEBUG OFF")
			debug=nil
		else
			print("BLTNorushen DEBUG ON")
			debug=true
		end
	end
end

local function announce(target)
  SendChatMessage("GO DOWN "..target ,"RAID_WARNING")
  SendChatMessage("GO DOWN IN "..tostring(beforetime).." seconds !", "WHISPER", "Common", target)
end

local function createNextDPS(time)
  DBM:CreatePizzaTimer(time, "#"..tostring(currentdps).." "..BLTNorushen.db.profile['dps'..tostring(currentdps)], true)
  BLTNorushen:ScheduleTimer(announce, time-beforetime, BLTNorushen.db.profile['dps'..tostring(currentdps)])
  currentdps=currentdps+1
end

local function rotation()
  if bossfight and currentdps<18 then
    createNextDPS(rotationtime)
    BLTNorushen:ScheduleTimer(rotation, rotationtime)
  end
end

function BLTNorushen:CHAT_MSG_MONSTER_YELL(event, msg, _, _, _, target)
	if debug then
		print("BLTNorushen CHAT_MSG_MONSTER_YELL received msg:"..msg)
	end
	if not msg:find(Lwasteoftime) then return end
  
  bossfight=true
  currentdps=1
  
	for i = 1, BLTNorushen.db.profile['numPrepull'] do
    createNextDPS(prepulltime)
  end
  BLTNorushen:ScheduleTimer(rotation, prepulltime)
end

local function checkForWipe()
	local w = true
	local num = GetNumGroupMembers()
	for i = 1, num do
		local name = GetRaidRosterInfo(i)
		if name then
			if UnitAffectingCombat(name) then
				w = false
			end
		end
	end
	if (w and bossfight) then
		if debug then
			print ("BLTNorushen Wipe detected")
		end
		bossfight = false
	end
	if not w then BLTNorushen:ScheduleTimer(checkForWipe, 2) end
end

function BLTNorushen:PLAYER_REGEN_ENABLED()
	checkForWipe()
end

function BLTNorushen:OnInitialize()
	if count == 1 then return end

	BLTNorushen:RegisterChatCommand("BLTN", "SlashProcessor_BLTNorushen")
	BLTNorushen:RegisterEvent("PLAYER_REGEN_ENABLED")
	BLTNorushen:RegisterEvent("CHAT_MSG_MONSTER_YELL")

	BLTNorushen.db = AceDB:New("BLTNorushenDB", BLTNorushen.defaults, true)
	BLTNorushen.SetupOptions()
	count = 1;
end
